#include "Transfer85.h"
//extern ofstream logfile;
extern HWND hDlg;
extern int totalBytes;

byte* GetScreen() {
   byte sdata[] = {0x05, P_SCRNDUMP, 0,0};
   byte* scrn = new byte[1024];
   byte* rdata;

   SendFPacket(sdata, true);
   SetDlgItemText(hDlg, IDC_NAME, "Screen Image");
   rdata = RecvPacket();
   if (!rdata) return NULL;
   for(int i=0; i< 1024; i++)
      scrn[i] = rdata[i+4];
   delete rdata;
   return scrn;
}

void OutputImage(byte* img) {
   int i,j=0,k;

   for(i=0;i<1024;i++) {
      if (j==16) {
      j=0;
//         logfile << endl;
      }
      k=128;
      do {
//         if (k & img[i]) logfile << '#';
//         else logfile << ' ';
         k >>= 1;
      } while (k > 0);
      j++;
   }
//   logfile << endl;
}

void SendPacket(byte cmd, byte* data, bool reply) {
	// Format packet, then send
   int size, check=0, ind, perc=0, operc;
   char buff[5], *name, temp;

//   logfile << "Send:";
   do {
      SendByte(0x05); // Should be 0x05
      SendByte(cmd); // Command
      SendByte(size = data[0]); // Packet length_low
      SendByte(data[1]); // Packet length_high
      size += data[1]*256;
      if (cmd == P_VARIABLE) { // Set Name in Dialog Box
         name = &data[6];
         ind = data[5]+6;
         temp = data[ind];
         data[ind] = '\0';
         SetDlgItemText(hDlg, IDC_NAME, name);
         data[ind] = temp;
      }
      if (size) {
         for (int i=0; i<size; i++) {
            check += data[i+2];
            SendByte(data[i+2]);
            totalBytes++;
            if (cmd == P_DATA) {
               operc = perc;
               perc = 100*(i+1)/size;
               if (perc != operc) {
                  wsprintf(buff, "%d%%", perc);
                  SetDlgItemText(hDlg, IDC_PERCENT, buff);
                  SendDlgItemMessage(hDlg, IDC_PROGRESS, PBM_SETPOS, perc, 0);
               }
            }
         }
         check &= 0xFFFF;
         SendByte(check % 256);
         SendByte(check / 256);
      }
//      logfile <<  endl;
   } while (reply && GetOK()!=P_OK);
}

void SendFPacket(byte* data, bool reply) {
   // Send Formatted Packet
   int size, check=0;

//   logfile << "Send: ";
   do {
      SendByte(data[0]); // Should be 0x05
      SendByte(data[1]); // Command
      SendByte(size = data[2]); // Packet length_low
      SendByte(size += data[3]*256); // Packet length_high
      if (size) {
         for (int i=0; i<size; i++) {
            totalBytes++;
            check += data[i+4];
            SendByte(data[i+4]);
         }
         check &= 0xFFFF;
         SendByte(check % 256);
         SendByte(check / 256);
      }
//      logfile << endl;
   } while (reply && GetOK()!=P_OK);

}

byte GetOK() {
   byte ret;

//   logfile << "Recv:" << flush;
   RecvByte();
   ret = RecvByte();
   RecvByte();
   RecvByte();
//   if (ret == P_OK)
//      logfile << " OK" << endl;
//   else
//      logfile << " Resend" << endl;
   return ret;
}

byte GetAnswer() {
   byte ret;

//   logfile << "Recv:";
   RecvByte();
   ret = RecvByte();
   RecvByte();   // length
   RecvByte();
   if (ret == P_ANSWER) {
      ret = RecvByte();
      RecvByte(); // Checksum
      RecvByte();
   }
//   if (ret == P_CONTINUE)
//      logfile << " Continue" << endl;
//   else if (ret == ANS_SKIP)
//      logfile << " Skip" << endl;
//   else if (ret == ANS_EXIT)
//      logfile << " Exit" << endl;
//   else
//      logfile << " Out of Mem" << endl;
   return ret;
}

byte* RecvPacket(bool reply) {
   byte* data;
   byte temp[4];
   int i,size,perc=0,operc;
   char buff[5];

//   logfile << "Recv:";
   for (i=0;i<4;i++)
      temp[i]=RecvByte();
   size = temp[2] + temp[3]*256;
   data = new byte[size+4+(size ? 2:0)];
   for (i=0;i<4;i++)
      data[i] = temp[i];
   if (size) {
      for (i=0;i<size;i++) {
         data[i+4] = RecvByte();
         if (size>9) { // Arbitrary size
            operc = perc;
            perc = 100*(i+1)/size;
            if (perc != operc) {
               wsprintf(buff, "%d%%", perc);
               SetDlgItemText(hDlg, IDC_PERCENT, buff);
               SendDlgItemMessage(hDlg, IDC_PROGRESS, PBM_SETPOS, perc, 0);
            }
         }
      }
      RecvByte(); // Checksum -- use this someday
      RecvByte();
   }
//   logfile << endl;
   if (reply) SendOK();
   return data;
}

void SendOK() {
//   logfile << "Send:";
   SendByte(0x05);
   SendByte(P_OK);
   SendByte(0);
   SendByte(0);
//   logfile << " OK" << endl;
}

void SendVarDone() {
   byte sdata[] = {0x05, P_DONE, 0,0};
   SendFPacket(sdata, true);
}

