#define WIN32_LEAN_AND_MEAN
#include <windows.h>
//#include <string>
//using namespace std;
#include "Registry.h"

Registry::Registry(HKEY base, char* regPath) {
	LONG result = RegCreateKeyEx(base, regPath, 0, "regClass?",
   		REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &disp);
   if (result != ERROR_SUCCESS) hKey = NULL;
}

Registry::~Registry() {
	RegCloseKey(hKey);
}

int Registry::GetInt(char* name, int defval) {
   if (disp == REG_CREATED_NEW_KEY) return defval;

   DWORD dw;
   type=REG_DWORD;
	LRESULT result = RegQueryValueEx(hKey, name, NULL, &type, (LPBYTE)&dw, &size);
   if (result!=ERROR_SUCCESS)
   	dw = defval;
   return dw;
}

char* Registry::GetString(char* name, char* defval) {
   if (disp == REG_CREATED_NEW_KEY) return defval;

	char buffer[256];
   size=256;
   type=REG_SZ;
   LRESULT result = RegQueryValueEx(hKey, name, NULL, &type, (LPBYTE)buffer, &size);
   if (result!=ERROR_SUCCESS)
   	return defval;
   return strdup(buffer);
}

void Registry::SetInt(char* name, int data) {
   type=REG_DWORD;
   size=sizeof(DWORD);
	RegSetValueEx(hKey, name, 0, type, (LPBYTE)&data, size);
}

void Registry::SetString(char* name, char* data) {
	type=REG_SZ;
   size=strlen(data);
   RegSetValueEx(hKey, name, 0, type, (LPBYTE)data, size);
}
