#include "Transfer85.h"
#include <malloc.h>

//ofstream logfile("logfile.txt");
HANDLE hPort;
HINSTANCE hInst;
HWND hDlg;
int totalBytes;
DWORD tid;
HANDLE hThread = 0;
char* lastFile = NULL;

char* comPort = strdup("COM2");

int WINAPI WinMain(HINSTANCE hi, HINSTANCE, LPSTR cmdline, int) {
   hInst = hi;
   InitCommonControls();

   Registry reg(HKEY_CURRENT_USER, "Software\\OrbWorks\\Transfer85");
   int portNum = reg.GetInt("COMport", 0);
   if (!portNum) {
      portNum = DialogBox(hInst, MAKEINTRESOURCE(IDD_INIT), NULL, (DLGPROC)SetupDlg);
      if (!portNum) return -1;
   }
   comPort[3] = (char)portNum + '0';
   if (!initializePort()) {
      MessageBox(NULL, "Could not allocate COM port.\n"
         "Check if another copy of Transfer-85 is running. Exiting...",
         "Transfer-85", MB_OK | MB_ICONSTOP);
      return -1;
   }
   // Create Dialog
   DialogBox(hInst, MAKEINTRESOURCE(IDD_MAIN), NULL, (DLGPROC)MainDlg);
   CloseHandle(hPort);
   reg.SetInt("COMport", comPort[3] - '0');
   return 0;
}

BOOL CALLBACK MainDlg(HWND h, UINT msg, WPARAM wParam, LPARAM) {
   switch (msg) {
      case WM_INITDIALOG:
         hDlg = h;
         DragAcceptFiles(hDlg, TRUE);
         return true;
      case WM_DROPFILES:
         SetDlgItemText(h, IDOK, "Cancel");
         hThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)HandleFileDrop, (HANDLE)wParam, 0, &tid);
         return false;
      case WM_COMMAND:
         switch (LOWORD(wParam)) {
            case IDCANCEL:
            case IDOK:
               if (tid) {
                  // This may cause resource leaks, but it is only for use in
                  // bad circumstances, so...
                  //if (!TerminateThread(hThread, 1))
                     //logfile << "Terminate thread failed: Error " <<
                     //   GetLastError() << endl;
                  SetDlgItemText(h, IDOK, "Close");
                  tid = 0;
               } else
                  EndDialog(h,0);
               return true;
            case IDC_SEND:
               SetDlgItemText(h, IDOK, "Cancel");
               hThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)SendButton, (HANDLE)wParam, 0, &tid);
               return true;
            case IDC_RECEIVE:
               SetDlgItemText(h, IDOK, "Cancel");
               hThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)ReSendButton, (HANDLE)wParam, 0, &tid);
               return true;
            case IDC_SETUP:
               SetupButton();
               return true;
         }
         return false;
   }
   return false;
}

LRESULT SendButton(DWORD) {
	OPENFILENAME OFNdata;
	char fileName[2048];
	fileName[0]=NULL;
   char* file;
   totalBytes=0;

	OFNdata.lStructSize=sizeof(OPENFILENAME);
	OFNdata.hwndOwner=hDlg;
	OFNdata.hInstance=0;
	OFNdata.lpstrFilter="TI-85 Files\0*.85?\0\0";
	OFNdata.lpstrCustomFilter=NULL;
	OFNdata.nMaxCustFilter=0;
	OFNdata.nFilterIndex=1;
	OFNdata.lpstrFile=fileName;
	OFNdata.nMaxFile=2048;
	OFNdata.lpstrFileTitle=NULL;
	OFNdata.nMaxFileTitle=0;
	OFNdata.lpstrInitialDir=NULL;
	OFNdata.lpstrTitle="Select TI-85 file(s)";
	OFNdata.Flags=OFN_FILEMUSTEXIST | OFN_HIDEREADONLY |
      OFN_EXPLORER | OFN_ALLOWMULTISELECT;
	OFNdata.lpstrDefExt="85s";

	if (GetOpenFileName(&OFNdata)) {
      int i=0;
      file = fileName;
      while (fileName[i]) i++;
      if (fileName[i+1]) {
         // Multiple files selected - skip path
         file = &fileName[i+1];
      }
      while (*file) {
         if (lastFile) free(lastFile);
         lastFile = strdup(file);
         if (!TransferFile(file)) break;
         while (*file++) ;
      }
      if (totalBytes) SendVarDone();
	}
   SetDlgItemText(hDlg, IDOK, "Close");
   tid = 0;
}

LRESULT ReSendButton(DWORD) {
   totalBytes=0;
   TransferFile(lastFile);
   if (totalBytes) SendVarDone();
   SetDlgItemText(hDlg, IDOK, "Close");
   tid = 0;
   return FALSE;
}

int SetupButton() {
   int com = DialogBox(hInst, MAKEINTRESOURCE(IDD_SETUP), NULL, (DLGPROC)SetupDlg);
   if (com) comPort[3] = (char)com+'0';
   return com;
}

BOOL CALLBACK SetupDlg(HWND h, UINT msg, WPARAM wParam, LPARAM) {
   HWND comBox;
   switch (msg) {
      case WM_INITDIALOG:
         comBox = GetDlgItem(h, IDC_COM);
         SendMessage(comBox, CB_ADDSTRING, 0, (LPARAM)"COM1");
         SendMessage(comBox, CB_ADDSTRING, 0, (LPARAM)"COM2");
         SendMessage(comBox, CB_ADDSTRING, 0, (LPARAM)"COM3");
         SendMessage(comBox, CB_ADDSTRING, 0, (LPARAM)"COM4");
         SendMessage(comBox, CB_SETCURSEL, (WPARAM)(comPort[3]-'1'), 0);
         return true;
      case WM_COMMAND:
         switch (LOWORD(wParam)) {
            case IDCANCEL:
               EndDialog(h, 0);
               return true;
            case IDOK:
               comBox = GetDlgItem(h, IDC_COM);
               EndDialog(h, SendMessage(comBox, CB_GETCURSEL, 0, 0)+1);
               return true;
         }
         return false;
   }
   return false;
}

LRESULT HandleFileDrop(HANDLE hDrop) {
   char file[MAX_PATH];
   int nFiles;
   totalBytes=0;

   nFiles = DragQueryFile(hDrop, -1, file, MAX_PATH);
   for (int i=0; i<nFiles; i++) {
      DragQueryFile(hDrop, i, file, MAX_PATH);
      if (lastFile) free(lastFile);
      lastFile = strdup(file);
      if (!TransferFile(file)) break;
   }
   if (totalBytes) SendVarDone();
   DragFinish(hDrop);
   SetDlgItemText(hDlg, IDOK, "Close");
   tid = 0;
   return FALSE; // Bogus return
}

/*LRESULT HandleCmdLineFiles(DWORD) {
   bool done = false;
   totalBytes = 0;
   std::string cmdline = GetCommandLine();

   if (cmdline[0]=='\"')
      TransferFile(cmdline.substr(1, cmdline.length() - 2).c_str());
   else
      MessageBox(NULL, "No support for multiple files on command line", "Transfer-85", MB_OK);
   ExitProcess(0);
}*/

bool initializePort() {
   DCB dcb;
   hPort = CreateFile(comPort, GENERIC_READ|GENERIC_WRITE, 0, NULL,
         OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_NO_BUFFERING,
         NULL);
   if (hPort==INVALID_HANDLE_VALUE) return false;
   GetCommState(hPort, &dcb);
   // This may be the hard part
   //BuildCommDCB("baud=96 parity=n data=8 stop=1 odsr=on octs=on idsr=on", &dcb);
   dcb.DCBlength = sizeof(DCB);
   dcb.BaudRate = CBR_9600;            // current baud rate
   dcb.fBinary = TRUE;          // binary mode, no EOF check
   dcb.fParity = FALSE;          // enable parity checking
   dcb.fOutxCtsFlow==FALSE;      // CTS output flow control
   dcb.fOutxDsrFlow==FALSE;      // DSR output flow control
   dcb.fDtrControl==DTR_CONTROL_DISABLE; // DTR flow control type
   dcb.fDsrSensitivity==FALSE;   // DSR sensitivity
   dcb.fTXContinueOnXoff==FALSE; // XOFF continues Tx
   dcb.fOutX = FALSE;        // XON/XOFF out flow control
   dcb.fInX = FALSE;         // XON/XOFF in flow control
   dcb.fErrorChar = FALSE;   // enable error replacement
   dcb.fNull = FALSE;        // enable null stripping
   dcb.fRtsControl==RTS_CONTROL_DISABLE;   // RTS flow control
   dcb.fAbortOnError = FALSE; // abort reads/writes on error
   dcb.ByteSize = 8;         // number of bits/byte, 4-8
   dcb.Parity = 0;           // 0-4=no,odd,even,mark,space
   dcb.StopBits = 1;         // 0,1,2 = 1, 1.5, 2

   SetCommState(hPort, &dcb);
   return true;
}

bool TransferFile(const char* file) {
   HANDLE hFile;
   int size;
   DWORD bytes;
   byte* data;

   hFile = CreateFile(file, GENERIC_READ, 0, NULL, OPEN_EXISTING,
         FILE_ATTRIBUTE_NORMAL, NULL);
   if (hFile==INVALID_HANDLE_VALUE) {
      char buffer[512];
      wsprintf(buffer, "Error opening file: %s", file);
      MessageBox(hDlg, buffer, "Transfer-85 Error", MB_OK | MB_ICONSTOP);
      return true;
   }
   size = GetFileSize(hFile, NULL);
   data = new byte[size];
   ReadFile(hFile, data, size, &bytes, NULL);
   CloseHandle(hFile);
   if (size != bytes) {
      char buffer[512];
      wsprintf(buffer, "Error while reading file: %s", file);
      MessageBox(hDlg, buffer, "Transfer-85 Error", MB_OK | MB_ICONSTOP);
      return true;
   }
   if (strncmp(data, "**TI85**", 8)!=0) {
      char buffer[512];
      wsprintf(buffer, "File: %s has incorrect signature", file);
      MessageBox(hDlg, buffer, "Transfer-85 Error", MB_OK | MB_ICONSTOP);
      return true;
   }

   int ptr = 0x37;
   int end = 0x37 + data[0x35] + data[0x36]*256;

   while (ptr < end) {
      if (!TransferVariable(&data[ptr])) break;
      ptr += (data[ptr] + data[ptr+1] * 256 + 2); // Skip header
      ptr += (data[ptr] + data[ptr+1] * 256 + 2); // Skip data
   }
   delete[] data;
   return (ptr >= end);
}

bool TransferVariable(byte* header) {
   byte reply;
   bool bckup = false;

   byte* data = &header[header[0] + header[1]*256 + 2];
   SendPacket(P_VARIABLE, header, true);
   if (header[4] == 0x1d) {
      bckup = true;
      SetDlgItemText(hDlg, IDC_NAME, "Chunk1");
   }
   reply = GetAnswer();
   SendOK();
   if (reply == P_CONTINUE) {
      SendPacket(P_DATA, data, true);
      if (bckup) {
         SetDlgItemText(hDlg, IDC_NAME, "Chunk2");
         data = &data[data[0] + data[1] * 256 + 2];
         SendPacket(P_DATA, data, true);
         SetDlgItemText(hDlg, IDC_NAME, "Chunk3");
         data = &data[data[0] + data[1] * 256 + 2];
         SendPacket(P_DATA, data, true);
         totalBytes=0; // To suppress SendVarDone()
         return false;
      }
      return true;
   } else if (reply == P_ANSWER) {
      if (reply == ANS_SKIP) return true;
   } else {
      // Reply was ABORT
      return false;
   }

   return true; // ?
}



