#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <shellapi.h>
#include <commctrl.h>
#include <commdlg.h>
#include <fstream.h>
#include "registry.h"
//#include <string>

// Transfer85.rh
#define IDD_SETUP	2
#define IDD_INIT  3
#define IDC_COM	101
#define IDI_ICON1	1
#define IDD_MAIN	1
#define IDC_PROGRESS	101
#define IDC_RECEIVE	103
#define IDC_SETUP	104
#define IDC_CLOSE	105
#define IDC_SEND	102
#define IDC_PERCENT 121
#define IDC_NAME 120

typedef unsigned char byte;

#define P_VARIABLE 	0x06
#define P_SCRNDUMP   0x6d
#define P_DATA       0x15
#define P_OK         0x56
#define P_RESEND		0x5a
#define P_DONE       0x92
#define P_ANSWER  	0x36
#define P_CONTINUE   0x09
#define ANS_SKIP		0x02
#define ANS_EXIT		0x01
#define ANS_OUTOFMEM 0x03

// Windows/UI functions
BOOL CALLBACK MainDlg(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK SetupDlg(HWND, UINT, WPARAM, LPARAM);
LRESULT SendButton(DWORD);
LRESULT ReSendButton(DWORD);
int SetupButton();
LRESULT HandleFileDrop(HANDLE);
LRESULT HandleCmdLineFiles(DWORD);

// High level functions
bool initializePort();
void EndTransfer();
bool TransferFile(const char*);
bool TransferVariable(byte*);
void StoreBMP(char*, byte*);	// Build BMP file from Screen Image

// High level Send/Recv
void SendVarHeader(byte*);
void SendVarData(byte*);
void SendVarDone();
byte GetOK();						// Returns P_OK or P_RESEND
byte GetAnswer();             // Returns P_CONTINUE or ANS_*
byte* GetScreen();
byte* WaitForVars();
void Store85g(byte*);

// Low-level Send/Recv
void SendFPacket(byte*, bool reply);
void SendPacket(byte, byte*, bool reply);
byte* RecvPacket(bool = false);
void SendByte(byte);
byte RecvByte();
void SendOK();

// Debugging functions
void OutputImage(byte*);
